Index: /branches/numpy/anuga/shallow_water/shallow_water_ext.c
===================================================================
--- /branches/numpy/anuga/shallow_water/shallow_water_ext.c	(revision 6901)
+++ /branches/numpy/anuga/shallow_water/shallow_water_ext.c	(revision 6902)
@@ -28,4 +28,5 @@
 
 // Computational function for rotation
+// FIXME: Perhaps inline this and profile
 int _rotate(double *q, double n1, double n2) {
   /*Rotate the momentum component q (q[1], q[2])
@@ -52,5 +53,5 @@
 
 int find_qmin_and_qmax(double dq0, double dq1, double dq2, 
-		       double *qmin, double *qmax){
+               double *qmin, double *qmax){
   // Considering the centroid of an FV triangle and the vertices of its 
   // auxiliary triangle, find 
@@ -67,8 +68,8 @@
     if (dq1>=dq2){
       if (dq1>=0.0)
-	*qmax=dq0+dq1;
+    *qmax=dq0+dq1;
       else
-	*qmax=dq0;
-	
+    *qmax=dq0;
+    
       *qmin=dq0+dq2;
       if (*qmin>=0.0) *qmin = 0.0;
@@ -76,9 +77,9 @@
     else{// dq1<dq2
       if (dq2>0)
-	*qmax=dq0+dq2;
+    *qmax=dq0+dq2;
       else
-	*qmax=dq0;
-	
-      *qmin=dq0+dq1;	
+    *qmax=dq0;
+    
+      *qmin=dq0+dq1;    
       if (*qmin>=0.0) *qmin=0.0;
     }
@@ -87,17 +88,17 @@
     if (dq1<=dq2){
       if (dq1<0.0)
-	*qmin=dq0+dq1;
+    *qmin=dq0+dq1;
       else
-	*qmin=dq0;
-	
-      *qmax=dq0+dq2;	
+    *qmin=dq0;
+    
+      *qmax=dq0+dq2;    
       if (*qmax<=0.0) *qmax=0.0;
     }
     else{// dq1>dq2
       if (dq2<0.0)
-	*qmin=dq0+dq2;
+    *qmin=dq0+dq2;
       else
-	*qmin=dq0;
-	
+    *qmin=dq0;
+    
       *qmax=dq0+dq1;
       if (*qmax<=0.0) *qmax=0.0;
@@ -133,6 +134,8 @@
   
   phi=min(r*beta_w,1.0);
-  for (i=0;i<3;i++)
-    dqv[i]=dqv[i]*phi;
+  //for (i=0;i<3;i++)
+  dqv[0]=dqv[0]*phi;
+  dqv[1]=dqv[1]*phi;
+  dqv[2]=dqv[2]*phi;
     
   return 0;
@@ -141,8 +144,8 @@
 
 double compute_froude_number(double uh,
-			     double h, 
-			     double g,
-			     double epsilon) {
-			  
+                 double h, 
+                 double g,
+                 double epsilon) {
+              
   // Compute Froude number; v/sqrt(gh)
   // FIXME (Ole): Not currently in use
@@ -166,8 +169,10 @@
 // This is used by flux functions
 // Input parameters uh and h may be modified by this function.
+
+// FIXME: Perhaps inline this and profile
 double _compute_speed(double *uh, 
-		      double *h, 
-		      double epsilon, 
-		      double h0) {
+              double *h, 
+              double epsilon, 
+              double h0) {
   
   double u;
@@ -188,10 +193,67 @@
 }
 
+
+// Optimised squareroot computation
+//
+//See 
+//http://www.lomont.org/Math/Papers/2003/InvSqrt.pdf
+//and http://mail.opensolaris.org/pipermail/tools-gcc/2005-August/000047.html
+float fast_squareroot_approximation(float number) {
+  float x; 
+  const float f = 1.5;
+
+  // Allow i and y to occupy the same memory
+  union
+  {
+    long i;
+    float y;
+  } u;
+  
+  // Good initial guess  
+  x = number * 0.5;  
+  u.y  = number;
+  u.i  = 0x5f3759df - ( u.i >> 1 );
+  
+  // Take a few iterations
+  u.y  = u.y * ( f - ( x * u.y * u.y ) );
+  u.y  = u.y * ( f - ( x * u.y * u.y ) );
+    
+  return number * u.y;
+}
+
+
+
+// Optimised squareroot computation (double version, slower)
+double Xfast_squareroot_approximation(double number) {
+  double x;
+  const double f = 1.5;
+    
+  // Allow i and y to occupy the same memory    
+  union
+  {
+    long long i;
+    double y;
+  } u;
+
+  // Good initial guess
+  x = number * 0.5;
+  u.y  = number;
+  u.i  = 0x5fe6ec85e7de30daLL - ( u.i >> 1 );
+  
+  // Take a few iterations  
+  u.y  = u.y * ( f - ( x * u.y * u.y ) );
+  u.y  = u.y * ( f - ( x * u.y * u.y ) );
+
+  return number * u.y;
+}
+
+
 // Innermost flux function (using stage w=z+h)
 int _flux_function_central(double *q_left, double *q_right,
-			   double z_left, double z_right,
-			   double n1, double n2,
-			   double epsilon, double H0, double g,
-			   double *edgeflux, double *max_speed) {
+                           double z_left, double z_right,
+                           double n1, double n2,
+                           double epsilon, double H0, double g,
+                           double *edgeflux, double *max_speed) 
+{
 
   /*Compute fluxes between volumes for the shallow water wave equation
@@ -212,5 +274,5 @@
   double v_left, v_right;  
   double s_min, s_max, soundspeed_left, soundspeed_right;
-  double denom, z;
+  double denom, inverse_denominator, z;
 
   // Workspace (allocate once, use many)
@@ -219,11 +281,13 @@
   double h0 = H0*H0; // This ensures a good balance when h approaches H0.
                      // But evidence suggests that h0 can be as little as
-		     // epsilon!
+             // epsilon!
   
   // Copy conserved quantities to protect from modification
-  for (i=0; i<3; i++) {
-    q_left_rotated[i] = q_left[i];
-    q_right_rotated[i] = q_right[i];
-  }
+  q_left_rotated[0] = q_left[0];
+  q_right_rotated[0] = q_right[0];
+  q_left_rotated[1] = q_left[1];
+  q_right_rotated[1] = q_right[1];
+  q_left_rotated[2] = q_left[2];
+  q_right_rotated[2] = q_right[2];
 
   // Align x- and y-momentum with x-axis
@@ -231,17 +295,17 @@
   _rotate(q_right_rotated, n1, n2);
 
-  z = (z_left+z_right)/2; // Average elevation values. 
-                          // Even though this will nominally allow for discontinuities 
-			  // in the elevation data, there is currently no numerical 
-			  // support for this so results may be strange near jumps in the bed.
+  z = 0.5*(z_left + z_right); // Average elevation values. 
+                            // Even though this will nominally allow for discontinuities 
+                            // in the elevation data, there is currently no numerical 
+                            // support for this so results may be strange near jumps in the bed.
 
   // Compute speeds in x-direction
   w_left = q_left_rotated[0];          
-  h_left = w_left-z;
+  h_left = w_left - z;
   uh_left = q_left_rotated[1];
   u_left = _compute_speed(&uh_left, &h_left, epsilon, h0);
 
   w_right = q_right_rotated[0];
-  h_right = w_right-z;
+  h_right = w_right - z;
   uh_right = q_right_rotated[1];
   u_right = _compute_speed(&uh_right, &h_right, epsilon, h0);  
@@ -257,12 +321,21 @@
   // Maximal and minimal wave speeds
   soundspeed_left  = sqrt(g*h_left);
-  soundspeed_right = sqrt(g*h_right);
-
-  s_max = max(u_left+soundspeed_left, u_right+soundspeed_right);
-  if (s_max < 0.0) s_max = 0.0;
-
-  s_min = min(u_left-soundspeed_left, u_right-soundspeed_right);
-  if (s_min > 0.0) s_min = 0.0;
-
+  soundspeed_right = sqrt(g*h_right);  
+  
+  // Code to use fast square root optimisation if desired.
+  //soundspeed_left  = fast_squareroot_approximation(g*h_left);
+  //soundspeed_right = fast_squareroot_approximation(g*h_right);
+
+  s_max = max(u_left + soundspeed_left, u_right + soundspeed_right);
+  if (s_max < 0.0) 
+  {
+    s_max = 0.0;
+  }
+
+  s_min = min(u_left - soundspeed_left, u_right - soundspeed_right);
+  if (s_min > 0.0)
+  {
+    s_min = 0.0;
+  }
   
   // Flux formulas
@@ -275,15 +348,19 @@
   flux_right[2] = u_right*vh_right;
 
-  
   // Flux computation
-  denom = s_max-s_min;
-  if (denom < epsilon) { // FIXME (Ole): Try using H0 here
-    for (i=0; i<3; i++) edgeflux[i] = 0.0;
+  denom = s_max - s_min;
+  if (denom < epsilon) 
+  { // FIXME (Ole): Try using H0 here
+    memset(edgeflux, 0, 3*sizeof(double));
     *max_speed = 0.0;
-  } else {
-    for (i=0; i<3; i++) {
+  } 
+  else 
+  {
+    inverse_denominator = 1.0/denom;
+    for (i = 0; i < 3; i++) 
+    {
       edgeflux[i] = s_max*flux_left[i] - s_min*flux_right[i];
-      edgeflux[i] += s_max*s_min*(q_right_rotated[i]-q_left_rotated[i]);
-      edgeflux[i] /= denom;
+      edgeflux[i] += s_max*s_min*(q_right_rotated[i] - q_left_rotated[i]);
+      edgeflux[i] *= inverse_denominator;
     }
 
@@ -315,8 +392,8 @@
 // Computational function for flux computation (using stage w=z+h)
 int flux_function_kinetic(double *q_left, double *q_right,
-		  double z_left, double z_right,
-		  double n1, double n2,
-		  double epsilon, double H0, double g,
-		  double *edgeflux, double *max_speed) {
+          double z_left, double z_right,
+          double n1, double n2,
+          double epsilon, double H0, double g,
+          double *edgeflux, double *max_speed) {
 
   /*Compute fluxes between volumes for the shallow water wave equation
@@ -413,7 +490,7 @@
 
 void _manning_friction(double g, double eps, int N,
-		       double* w, double* z,
-		       double* uh, double* vh,
-		       double* eta, double* xmom, double* ymom) {
+               double* w, double* z,
+               double* uh, double* vh,
+               double* eta, double* xmom, double* ymom) {
 
   int k;
@@ -426,5 +503,5 @@
         S = -g * eta[k]*eta[k] * sqrt((uh[k]*uh[k] + vh[k]*vh[k]));
         S /= pow(h, 7.0/3);      //Expensive (on Ole's home computer)
-        //S /= exp(7.0/3.0*log(h));      //seems to save about 15% over manning_friction
+        //S /= exp((7.0/3.0)*log(h));      //seems to save about 15% over manning_friction
         //S /= h*h*(1 + h/3.0 - h*h/9.0); //FIXME: Could use a Taylor expansion
 
@@ -441,7 +518,7 @@
 /*
 void _manning_friction_explicit(double g, double eps, int N,
-		       double* w, double* z,
-		       double* uh, double* vh,
-		       double* eta, double* xmom, double* ymom) {
+               double* w, double* z,
+               double* uh, double* vh,
+               double* eta, double* xmom, double* ymom) {
 
   int k;
@@ -452,13 +529,13 @@
       h = w[k]-z[k];
       if (h >= eps) {
-	S = -g * eta[k]*eta[k] * sqrt((uh[k]*uh[k] + vh[k]*vh[k]));
-	S /= pow(h, 7.0/3);      //Expensive (on Ole's home computer)
-	//S /= exp(7.0/3.0*log(h));      //seems to save about 15% over manning_friction
-	//S /= h*h*(1 + h/3.0 - h*h/9.0); //FIXME: Could use a Taylor expansion
-
-
-	//Update momentum
-	xmom[k] += S*uh[k];
-	ymom[k] += S*vh[k];
+    S = -g * eta[k]*eta[k] * sqrt((uh[k]*uh[k] + vh[k]*vh[k]));
+    S /= pow(h, 7.0/3);      //Expensive (on Ole's home computer)
+    //S /= exp(7.0/3.0*log(h));      //seems to save about 15% over manning_friction
+    //S /= h*h*(1 + h/3.0 - h*h/9.0); //FIXME: Could use a Taylor expansion
+
+
+    //Update momentum
+    xmom[k] += S*uh[k];
+    ymom[k] += S*vh[k];
       }
     }
@@ -471,11 +548,11 @@
 
 double velocity_balance(double uh_i, 
-			double uh,
-			double h_i, 
-			double h, 
-			double alpha,
-			double epsilon) {
+            double uh,
+            double h_i, 
+            double h, 
+            double alpha,
+            double epsilon) {
   // Find alpha such that speed at the vertex is within one
-  // order of magnitude of the centroid speed	
+  // order of magnitude of the centroid speed   
 
   // FIXME(Ole): Work in progress
@@ -486,5 +563,5 @@
   
   printf("alpha = %f, uh_i=%f, uh=%f, h_i=%f, h=%f\n",
-	 alpha, uh_i, uh, h_i, h);
+     alpha, uh_i, uh, h_i, h);
       
   
@@ -500,5 +577,5 @@
   if (h < epsilon) {
     b = 1.0e10; // Limit
-  } else {	 
+  } else {   
     b = m*fabs(h_i - h)/h;
   }
@@ -507,12 +584,12 @@
 
   if (a > b) {
-    estimate = (m-1)/(a-b);		
+    estimate = (m-1)/(a-b);     
     
     printf("Alpha %f, estimate %f\n", 
-	   alpha, estimate);    
-	   
+       alpha, estimate);    
+       
     if (alpha < estimate) {
       printf("Adjusting alpha from %f to %f\n", 
-	     alpha, estimate);
+         alpha, estimate);
       alpha = estimate;
     }
@@ -520,13 +597,13 @@
   
     if (h < h_i) {
-      estimate = (m-1)/(a-b);		      
+      estimate = (m-1)/(a-b);             
     
       printf("Alpha %f, estimate %f\n", 
-	     alpha, estimate);    
-	   
+         alpha, estimate);    
+       
       if (alpha < estimate) {
-	printf("Adjusting alpha from %f to %f\n", 
-	       alpha, estimate);
-	alpha = estimate;
+    printf("Adjusting alpha from %f to %f\n", 
+           alpha, estimate);
+    alpha = estimate;
       }    
     }
@@ -540,17 +617,17 @@
 
 int _balance_deep_and_shallow(int N,
-			      double* wc,
-			      double* zc,
-			      double* wv,
-			      double* zv,
-			      double* hvbar, // Retire this
-			      double* xmomc,
-			      double* ymomc,
-			      double* xmomv,
-			      double* ymomv,
-			      double H0,
-			      int tight_slope_limiters,
-			      int use_centroid_velocities,
-			      double alpha_balance) {
+                  double* wc,
+                  double* zc,
+                  double* wv,
+                  double* zv,
+                  double* hvbar, // Retire this
+                  double* xmomc,
+                  double* ymomc,
+                  double* xmomv,
+                  double* ymomv,
+                  double H0,
+                  int tight_slope_limiters,
+                  int use_centroid_velocities,
+                  double alpha_balance) {
 
   int k, k3, i; 
@@ -579,5 +656,5 @@
       // FIXME: Try with this one precomputed
       for (i=0; i<3; i++) {
-	dz = max(dz, fabs(zv[k3+i]-zc[k]));
+    dz = max(dz, fabs(zv[k3+i]-zc[k]));
       }
     }
@@ -592,5 +669,5 @@
 
     //if (hmin < 0.0 ) {
-    //	printf("hmin = %f\n",hmin);
+    //  printf("hmin = %f\n",hmin);
     //}
     
@@ -607,7 +684,7 @@
       
       if (dz > 0.0) {
-	alpha = max( min( alpha_balance*hmin/dz, 1.0), 0.0 );      
+    alpha = max( min( alpha_balance*hmin/dz, 1.0), 0.0 );      
       } else {
-	alpha = 1.0;  // Flat bed
+    alpha = 1.0;  // Flat bed
       }
       //printf("Using old style limiter\n");
@@ -622,47 +699,47 @@
     
       if (hmin < H0) {
-	alpha = 1.0;
-	for (i=0; i<3; i++) {
-	  
-	  h_diff = hc_k - hv[i];	  
-	  if (h_diff <= 0) {
-	    // Deep water triangle is further away from bed than 
-	    // shallow water (hbar < h). Any alpha will do
-	  
-	  } else {  
-	    // Denominator is positive which means that we need some of the 
-	    // h-limited stage.
-	    
-	    alpha = min(alpha, (hc_k - H0)/h_diff);	    
-	  }
-	}
-
-	// Ensure alpha in [0,1]
-	if (alpha>1.0) alpha=1.0;
-	if (alpha<0.0) alpha=0.0;
-	
+    alpha = 1.0;
+    for (i=0; i<3; i++) {
+      
+      h_diff = hc_k - hv[i];      
+      if (h_diff <= 0) {
+        // Deep water triangle is further away from bed than 
+        // shallow water (hbar < h). Any alpha will do
+      
+      } else {  
+        // Denominator is positive which means that we need some of the 
+        // h-limited stage.
+        
+        alpha = min(alpha, (hc_k - H0)/h_diff);     
+      }
+    }
+
+    // Ensure alpha in [0,1]
+    if (alpha>1.0) alpha=1.0;
+    if (alpha<0.0) alpha=0.0;
+    
       } else {
-	// Use w-limited stage exclusively in deeper water.
-	alpha = 1.0;       
+    // Use w-limited stage exclusively in deeper water.
+    alpha = 1.0;       
       }
     }
 
 
-    //	Let
+    //  Let
     //
-    //	  wvi be the w-limited stage (wvi = zvi + hvi)
-    //	  wvi- be the h-limited state (wvi- = zvi + hvi-)
+    //    wvi be the w-limited stage (wvi = zvi + hvi)
+    //    wvi- be the h-limited state (wvi- = zvi + hvi-)
     //
     //
-    //	where i=0,1,2 denotes the vertex ids
+    //  where i=0,1,2 denotes the vertex ids
     //
     //  Weighted balance between w-limited and h-limited stage is
     //
-    //	  wvi := (1-alpha)*(zvi+hvi-) + alpha*(zvi+hvi)
+    //    wvi := (1-alpha)*(zvi+hvi-) + alpha*(zvi+hvi)
     //
     //  It follows that the updated wvi is
     //    wvi := zvi + (1-alpha)*hvi- + alpha*hvi
     //
-    //	 Momentum is balanced between constant and limited
+    //   Momentum is balanced between constant and limited
 
 
@@ -670,43 +747,43 @@
       for (i=0; i<3; i++) {
       
-	wv[k3+i] = zv[k3+i] + (1-alpha)*hc_k + alpha*hv[i];	
-
-	// Update momentum at vertices
-	if (use_centroid_velocities == 1) {
-	  // This is a simple, efficient and robust option
-	  // It uses first order approximation of velocities, but retains
-	  // the order used by stage.
-	
-	  // Speeds at centroids
-	  if (hc_k > epsilon) {
-	    uc = xmomc[k]/hc_k;
-	    vc = ymomc[k]/hc_k;
-	  } else {
-	    uc = 0.0;
-	    vc = 0.0;
-	  }
-	  
-	  // Vertex momenta guaranteed to be consistent with depth guaranteeing
-	  // controlled speed
-	  hv[i] = wv[k3+i] - zv[k3+i]; // Recompute (balanced) vertex depth
-	  xmomv[k3+i] = uc*hv[i];
-	  ymomv[k3+i] = vc*hv[i];
-	  
-	} else {
-	  // Update momentum as a linear combination of
-	  // xmomc and ymomc (shallow) and momentum
-	  // from extrapolator xmomv and ymomv (deep).
-	  // This assumes that values from xmomv and ymomv have
-	  // been established e.g. by the gradient limiter.
-
-	  // FIXME (Ole): I think this should be used with vertex momenta
-	  // computed above using centroid_velocities instead of xmomc 
-	  // and ymomc as they'll be more representative first order
-	  // values.
-	  
-	  xmomv[k3+i] = (1-alpha)*xmomc[k] + alpha*xmomv[k3+i];
-	  ymomv[k3+i] = (1-alpha)*ymomc[k] + alpha*ymomv[k3+i];
-	
-	}
+    wv[k3+i] = zv[k3+i] + (1-alpha)*hc_k + alpha*hv[i]; 
+
+    // Update momentum at vertices
+    if (use_centroid_velocities == 1) {
+      // This is a simple, efficient and robust option
+      // It uses first order approximation of velocities, but retains
+      // the order used by stage.
+    
+      // Speeds at centroids
+      if (hc_k > epsilon) {
+        uc = xmomc[k]/hc_k;
+        vc = ymomc[k]/hc_k;
+      } else {
+        uc = 0.0;
+        vc = 0.0;
+      }
+      
+      // Vertex momenta guaranteed to be consistent with depth guaranteeing
+      // controlled speed
+      hv[i] = wv[k3+i] - zv[k3+i]; // Recompute (balanced) vertex depth
+      xmomv[k3+i] = uc*hv[i];
+      ymomv[k3+i] = vc*hv[i];
+      
+    } else {
+      // Update momentum as a linear combination of
+      // xmomc and ymomc (shallow) and momentum
+      // from extrapolator xmomv and ymomv (deep).
+      // This assumes that values from xmomv and ymomv have
+      // been established e.g. by the gradient limiter.
+
+      // FIXME (Ole): I think this should be used with vertex momenta
+      // computed above using centroid_velocities instead of xmomc 
+      // and ymomc as they'll be more representative first order
+      // values.
+      
+      xmomv[k3+i] = (1-alpha)*xmomc[k] + alpha*xmomv[k3+i];
+      ymomv[k3+i] = (1-alpha)*ymomc[k] + alpha*ymomv[k3+i];
+    
+    }
       }
     }
@@ -719,11 +796,11 @@
 
 int _protect(int N,
-	     double minimum_allowed_height,
-	     double maximum_allowed_speed,
-	     double epsilon,
-	     double* wc,
-	     double* zc,
-	     double* xmomc,
-	     double* ymomc) {
+         double minimum_allowed_height,
+         double maximum_allowed_speed,
+         double epsilon,
+         double* wc,
+         double* zc,
+         double* xmomc,
+         double* ymomc) {
 
   int k;
@@ -738,9 +815,9 @@
 
       if (hc < minimum_allowed_height) {
-    	
-	// Set momentum to zero and ensure h is non negative
-	xmomc[k] = 0.0;
-	ymomc[k] = 0.0;
-	if (hc <= 0.0) wc[k] = zc[k];
+        
+    // Set momentum to zero and ensure h is non negative
+    xmomc[k] = 0.0;
+    ymomc[k] = 0.0;
+    if (hc <= 0.0) wc[k] = zc[k];
       }
     }
@@ -757,27 +834,27 @@
               
         if (hc <= 0.0) {
-        	wc[k] = zc[k];
-    	xmomc[k] = 0.0;
-    	ymomc[k] = 0.0;
+            wc[k] = zc[k];
+        xmomc[k] = 0.0;
+        ymomc[k] = 0.0;
         } else {
           //Reduce excessive speeds derived from division by small hc
-    	//FIXME (Ole): This may be unnecessary with new slope limiters 
-    	//in effect.
+        //FIXME (Ole): This may be unnecessary with new slope limiters 
+        //in effect.
           
           u = xmomc[k]/hc;
-	  if (fabs(u) > maximum_allowed_speed) {
-	    reduced_speed = maximum_allowed_speed * u/fabs(u);
-	    //printf("Speed (u) has been reduced from %.3f to %.3f\n",
-	    //	 u, reduced_speed);
-	    xmomc[k] = reduced_speed * hc;
-	  }
+      if (fabs(u) > maximum_allowed_speed) {
+        reduced_speed = maximum_allowed_speed * u/fabs(u);
+        //printf("Speed (u) has been reduced from %.3f to %.3f\n",
+        //   u, reduced_speed);
+        xmomc[k] = reduced_speed * hc;
+      }
 
           v = ymomc[k]/hc;
-	  if (fabs(v) > maximum_allowed_speed) {
-	    reduced_speed = maximum_allowed_speed * v/fabs(v);
-	    //printf("Speed (v) has been reduced from %.3f to %.3f\n",
-	    //	 v, reduced_speed);
-	    ymomc[k] = reduced_speed * hc;
-	  }
+      if (fabs(v) > maximum_allowed_speed) {
+        reduced_speed = maximum_allowed_speed * v/fabs(v);
+        //printf("Speed (v) has been reduced from %.3f to %.3f\n",
+        //   v, reduced_speed);
+        ymomc[k] = reduced_speed * hc;
+      }
         }
       }
@@ -790,9 +867,9 @@
 
 int _assign_wind_field_values(int N,
-			      double* xmom_update,
-			      double* ymom_update,
-			      double* s_vec,
-			      double* phi_vec,
-			      double cw) {
+                  double* xmom_update,
+                  double* ymom_update,
+                  double* s_vec,
+                  double* phi_vec,
+                  double cw) {
 
   // Assign windfield values to momentum updates
@@ -839,6 +916,6 @@
 
   if (!PyArg_ParseTuple(args, "OOOddOddd",
-			&normal, &ql, &qr, &zl, &zr, &edgeflux,
-			&epsilon, &g, &H0)) {
+            &normal, &ql, &qr, &zl, &zr, &edgeflux,
+            &epsilon, &g, &H0)) {
     PyErr_SetString(PyExc_RuntimeError, "shallow_water_ext.c: flux_function_central could not parse input arguments");
     return NULL;
@@ -847,12 +924,12 @@
   
   _flux_function_central((double*) ql -> data, 
-			 (double*) qr -> data, 
-			 zl, 
-			 zr, 			 			 
-			 ((double*) normal -> data)[0],
-			 ((double*) normal -> data)[1],			 
-			 epsilon, H0, g,
-			 (double*) edgeflux -> data, 
-			 &max_speed);
+             (double*) qr -> data, 
+             zl, 
+             zr,                         
+             ((double*) normal -> data)[0],
+             ((double*) normal -> data)[1],          
+             epsilon, H0, g,
+             (double*) edgeflux -> data, 
+             &max_speed);
   
   return Py_BuildValue("d", max_speed);  
@@ -874,6 +951,6 @@
 
   if (!PyArg_ParseTuple(args, "dOOOOO",
-			&g, &h, &v, &x,
-			&xmom, &ymom)) {
+            &g, &h, &v, &x,
+            &xmom, &ymom)) {
     //&epsilon)) {
     PyErr_SetString(PyExc_RuntimeError, "shallow_water_ext.c: gravity could not parse input arguments");
@@ -940,6 +1017,6 @@
 
   if (!PyArg_ParseTuple(args, "ddOOOOOOO",
-			&g, &eps, &w, &z, &uh, &vh, &eta,
-			&xmom, &ymom)) {
+            &g, &eps, &w, &z, &uh, &vh, &eta,
+            &xmom, &ymom)) {
     PyErr_SetString(PyExc_RuntimeError, "shallow_water_ext.c: manning_friction could not parse input arguments");
     return NULL;
@@ -957,11 +1034,11 @@
   N = w -> dimensions[0];
   _manning_friction(g, eps, N,
-		    (double*) w -> data,
-		    (double*) z -> data,
-		    (double*) uh -> data,
-		    (double*) vh -> data,
-		    (double*) eta -> data,
-		    (double*) xmom -> data,
-		    (double*) ymom -> data);
+            (double*) w -> data,
+            (double*) z -> data,
+            (double*) uh -> data,
+            (double*) vh -> data,
+            (double*) eta -> data,
+            (double*) xmom -> data,
+            (double*) ymom -> data);
 
   return Py_BuildValue("");
@@ -981,6 +1058,6 @@
 
   if (!PyArg_ParseTuple(args, "ddOOOOOOO",
-			&g, &eps, &w, &z, &uh, &vh, &eta,
-			&xmom, &ymom))
+            &g, &eps, &w, &z, &uh, &vh, &eta,
+            &xmom, &ymom))
     return NULL;
 
@@ -996,11 +1073,11 @@
   N = w -> dimensions[0];
   _manning_friction_explicit(g, eps, N,
-		    (double*) w -> data,
-		    (double*) z -> data,
-		    (double*) uh -> data,
-		    (double*) vh -> data,
-		    (double*) eta -> data,
-		    (double*) xmom -> data,
-		    (double*) ymom -> data);
+            (double*) w -> data,
+            (double*) z -> data,
+            (double*) uh -> data,
+            (double*) vh -> data,
+            (double*) eta -> data,
+            (double*) xmom -> data,
+            (double*) ymom -> data);
 
   return Py_BuildValue("");
@@ -1012,43 +1089,44 @@
 // Computational routine
 int _extrapolate_second_order_sw(int number_of_elements,
-				  double epsilon,
-				  double minimum_allowed_height,
-				  double beta_w,
-				  double beta_w_dry,
-				  double beta_uh,
-				  double beta_uh_dry,
-				  double beta_vh,
-				  double beta_vh_dry,
-				  long* surrogate_neighbours,
-				  long* number_of_boundaries,
-				  double* centroid_coordinates,
-				  double* stage_centroid_values,
-				  double* xmom_centroid_values,
-				  double* ymom_centroid_values,
-				  double* elevation_centroid_values,
-				  double* vertex_coordinates,
-				  double* stage_vertex_values,
-				  double* xmom_vertex_values,
-				  double* ymom_vertex_values,
-				  double* elevation_vertex_values,
-				  int optimise_dry_cells) {
-				  
-				  
+                                 double epsilon,
+                                 double minimum_allowed_height,
+                                 double beta_w,
+                                 double beta_w_dry,
+                                 double beta_uh,
+                                 double beta_uh_dry,
+                                 double beta_vh,
+                                 double beta_vh_dry,
+                                 long* surrogate_neighbours,
+                                 long* number_of_boundaries,
+                                 double* centroid_coordinates,
+                                 double* stage_centroid_values,
+                                 double* xmom_centroid_values,
+                                 double* ymom_centroid_values,
+                                 double* elevation_centroid_values,
+                                 double* vertex_coordinates,
+                                 double* stage_vertex_values,
+                                 double* xmom_vertex_values,
+                                 double* ymom_vertex_values,
+                                 double* elevation_vertex_values,
+                                 int optimise_dry_cells) {
+                  
+                  
 
   // Local variables
   double a, b; // Gradient vector used to calculate vertex values from centroids
-  int k,k0,k1,k2,k3,k6,coord_index,i;
-  double x,y,x0,y0,x1,y1,x2,y2,xv0,yv0,xv1,yv1,xv2,yv2; // Vertices of the auxiliary triangle
-  double dx1,dx2,dy1,dy2,dxv0,dxv1,dxv2,dyv0,dyv1,dyv2,dq0,dq1,dq2,area2;
+  int k, k0, k1, k2, k3, k6, coord_index, i;
+  double x, y, x0, y0, x1, y1, x2, y2, xv0, yv0, xv1, yv1, xv2, yv2; // Vertices of the auxiliary triangle
+  double dx1, dx2, dy1, dy2, dxv0, dxv1, dxv2, dyv0, dyv1, dyv2, dq0, dq1, dq2, area2, inv_area2;
   double dqv[3], qmin, qmax, hmin, hmax;
   double hc, h0, h1, h2, beta_tmp, hfactor;
 
-	
-  for (k=0; k<number_of_elements; k++) {
+    
+  for (k = 0; k < number_of_elements; k++) 
+  {
     k3=k*3;
     k6=k*6;
 
-    
-    if (number_of_boundaries[k]==3){
+    if (number_of_boundaries[k]==3)
+    {
       // No neighbours, set gradient on the triangle to zero
       
@@ -1065,28 +1143,36 @@
       continue;
     }
-    else {
+    else 
+    {
       // Triangle k has one or more neighbours. 
       // Get centroid and vertex coordinates of the triangle
       
       // Get the vertex coordinates
-      xv0 = vertex_coordinates[k6];   yv0=vertex_coordinates[k6+1];
-      xv1 = vertex_coordinates[k6+2]; yv1=vertex_coordinates[k6+3];
-      xv2 = vertex_coordinates[k6+4]; yv2=vertex_coordinates[k6+5];
+      xv0 = vertex_coordinates[k6];   
+      yv0 = vertex_coordinates[k6+1];
+      xv1 = vertex_coordinates[k6+2]; 
+      yv1 = vertex_coordinates[k6+3];
+      xv2 = vertex_coordinates[k6+4]; 
+      yv2 = vertex_coordinates[k6+5];
       
       // Get the centroid coordinates
-      coord_index=2*k;
-      x=centroid_coordinates[coord_index];
-      y=centroid_coordinates[coord_index+1];
+      coord_index = 2*k;
+      x = centroid_coordinates[coord_index];
+      y = centroid_coordinates[coord_index+1];
       
       // Store x- and y- differentials for the vertices of 
       // triangle k relative to the centroid
-      dxv0=xv0-x; dxv1=xv1-x; dxv2=xv2-x;
-      dyv0=yv0-y; dyv1=yv1-y; dyv2=yv2-y;
+      dxv0 = xv0 - x; 
+      dxv1 = xv1 - x; 
+      dxv2 = xv2 - x;
+      dyv0 = yv0 - y; 
+      dyv1 = yv1 - y; 
+      dyv2 = yv2 - y;
     }
 
 
             
-    if (number_of_boundaries[k]<=1){
-    
+    if (number_of_boundaries[k]<=1)
+    {
       //==============================================
       // Number of boundaries <= 1
@@ -1099,26 +1185,28 @@
       // from this centroid and its two neighbours
       
-      k0=surrogate_neighbours[k3];
-      k1=surrogate_neighbours[k3+1];
-      k2=surrogate_neighbours[k3+2];
+      k0 = surrogate_neighbours[k3];
+      k1 = surrogate_neighbours[k3 + 1];
+      k2 = surrogate_neighbours[k3 + 2];
       
       // Get the auxiliary triangle's vertex coordinates 
       // (really the centroids of neighbouring triangles)
-      coord_index=2*k0;
-      x0=centroid_coordinates[coord_index];
-      y0=centroid_coordinates[coord_index+1];
-      
-      coord_index=2*k1;
-      x1=centroid_coordinates[coord_index];
-      y1=centroid_coordinates[coord_index+1];
-      
-      coord_index=2*k2;
-      x2=centroid_coordinates[coord_index];
-      y2=centroid_coordinates[coord_index+1];
+      coord_index = 2*k0;
+      x0 = centroid_coordinates[coord_index];
+      y0 = centroid_coordinates[coord_index+1];
+      
+      coord_index = 2*k1;
+      x1 = centroid_coordinates[coord_index];
+      y1 = centroid_coordinates[coord_index+1];
+      
+      coord_index = 2*k2;
+      x2 = centroid_coordinates[coord_index];
+      y2 = centroid_coordinates[coord_index+1];
       
       // Store x- and y- differentials for the vertices 
       // of the auxiliary triangle
-      dx1=x1-x0; dx2=x2-x0;
-      dy1=y1-y0; dy2=y2-y0;
+      dx1 = x1 - x0; 
+      dx2 = x2 - x0;
+      dy1 = y1 - y0; 
+      dy2 = y2 - y0;
       
       // Calculate 2*area of the auxiliary triangle
@@ -1128,8 +1216,10 @@
       // If the mesh is 'weird' near the boundary, 
       // the triangle might be flat or clockwise:
-      if (area2<=0) {
-	PyErr_SetString(PyExc_RuntimeError, 
-			"shallow_water_ext.c: negative triangle area encountered");
-	return -1;
+      if (area2 <= 0) 
+      {
+        PyErr_SetString(PyExc_RuntimeError, 
+                        "shallow_water_ext.c: negative triangle area encountered");
+    
+        return -1;
       }  
       
@@ -1139,23 +1229,25 @@
       h1 = stage_centroid_values[k1] - elevation_centroid_values[k1];
       h2 = stage_centroid_values[k2] - elevation_centroid_values[k2];
-      hmin = min(min(h0,min(h1,h2)),hc);
+      hmin = min(min(h0, min(h1, h2)), hc);
       //hfactor = hc/(hc + 1.0);
 
       hfactor = 0.0;
-      if (hmin > 0.001 ) {
-	  hfactor = (hmin-0.001)/(hmin+0.004);
-      }
-      
-      if (optimise_dry_cells) {      
-	// Check if linear reconstruction is necessary for triangle k
-	// This check will exclude dry cells.
-
-	hmax = max(h0,max(h1,h2));      
-	if (hmax < epsilon) {
-	  continue;
-	}
-      }
-
-            
+      if (hmin > 0.001) 
+      {
+        hfactor = (hmin - 0.001)/(hmin + 0.004);
+      }
+      
+      if (optimise_dry_cells) 
+      {      
+        // Check if linear reconstruction is necessary for triangle k
+        // This check will exclude dry cells.
+
+        hmax = max(h0, max(h1, h2));      
+        if (hmax < epsilon) 
+        {
+            continue;
+        }
+      }
+    
       //-----------------------------------
       // stage
